PopUpChoiceMorph subclass: #BorderedPopUpChoiceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-NewWidgets'!
!BorderedPopUpChoiceMorph commentStamp: '<historical>' prior: 0!
This one tries to look like a windows Combo Box!


!BorderedPopUpChoiceMorph methodsFor: 'drawing' stamp: 'JMV 6/25/1999 09:09'!
drawOn: aCanvas

	aCanvas frameAndFillRectangle: self bounds 
		fillColor: Color white 
		borderWidth: 2 
		borderColor: Color black.
	aCanvas text: contents 
		bounds: (bounds insetBy: 6@2)
		font: self fontToUse 
		color: color.
	aCanvas frameAndFillRectangle: (self topRight - (16@0) corner: self bottomRight)
		fillColor: Color lightGray 
		borderWidth: 2 
		borderColor: Color black.
	aCanvas image: (
		Form
			extent: 6@3
			fromArray: #(2r111111e26 2r1111e27 2r11e28)
			offset: 0@0) "displayAt: 10@10"
		at: self bottomRight - (11@9)
		sourceRect: (0@0 extent: 6@3)
		rule: Form and.! !


!BorderedPopUpChoiceMorph methodsFor: 'accessing' stamp: 'JMV 6/25/1999 08:48'!
fitContents

	| scanner |
	scanner _ QuickPrint newOn: Display box: Display boundingBox font: self fontToUse.
	self extent: ((scanner stringWidth: contents) @ (scanner lineHeight)) + (28@4).
	self changed.! !


PolygonMorph subclass: #MorphReferenceArrowMorph
	instanceVariableNames: 'referenced '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-NewWidgets'!

!MorphReferenceArrowMorph methodsFor: 'initialization' stamp: 'JMV 4/21/2000 21:31'!
initialize

	super initialize.
	self setVertices: (Array with: 20@20 with: 40@30).
	self makeOpen;
		makeForwardArrow;
		addHandles.! !


!MorphReferenceArrowMorph methodsFor: 'accessing' stamp: 'JMV 4/22/2000 12:38'!
referencedMorph

	^referenced! !


!MorphReferenceArrowMorph methodsFor: 'handle' stamp: 'JMV 4/24/2000 22:18'!
addHandles
	| handle vertPt vertIndex morphs |
	self comeToFront.
"	morphs _ World morphsAt: vertices last.
	morphs remove: World.
	morphs remove: self ifAbsent: [].
	handles notNil ifTrue: [
		morphs remove: handles last ifAbsent: [] ].
	morphs size > 0
		ifTrue: [ referenced _ (morphs first) ]
		ifFalse: [ referenced _ nil ]."
	morphs _ (World rootMorphsAt: vertices last) asOrderedCollection.
	morphs remove: self ifAbsent: [].
	morphs size > 0
		ifTrue: [ referenced _ (morphs first) ]
		ifFalse: [ referenced _ nil ].
	self removeHandles.
	handles _ OrderedCollection new.
	vertPt _ vertices last.
	vertIndex _ 2.
	handle _ EllipseMorph newBounds: (Rectangle center: vertPt extent: 8@8)
			color: Color yellow.
	handle on: #mouseStillDown send: #dragVertex:fromHandle:vertIndex:
			to: self withValue: vertIndex.
	handle on: #mouseUp send: #dropVertex:fromHandle:vertIndex:
			to: self withValue: vertIndex.
	self addMorph: handle.
	handles addLast: handle.
	self changed! !

!MorphReferenceArrowMorph methodsFor: 'handle' stamp: 'JMV 4/21/2000 20:38'!
updateHandles
	"Nothing to do"! !


RectangleMorph subclass: #MorphReferenceMorph
	instanceVariableNames: 'arrow '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-NewWidgets'!

!MorphReferenceMorph methodsFor: 'change reporting' stamp: 'JMV 4/21/2000 19:48'!
layoutChanged
	"Avoid an infinite recursion for updating the owner."

	fullBounds _ nil.! !

!MorphReferenceMorph methodsFor: 'change reporting' stamp: 'JMV 4/21/2000 21:02'!
ownerChanged
	"Avoid an infinite recursion for updating the owner."

"	self adjustArrow"! !


!MorphReferenceMorph methodsFor: 'accessing' stamp: 'JMV 4/22/2000 12:38'!
referencedMorph

	^arrow notNil
		ifTrue: [ arrow referencedMorph ]
		ifFalse: [ nil ]! !


!MorphReferenceMorph methodsFor: 'events' stamp: 'JMV 4/22/2000 12:31'!
handlesMouseDown: evt
	^ true! !

!MorphReferenceMorph methodsFor: 'events' stamp: 'JMV 4/24/2000 22:15'!
mouseUp: evt

	self deleteArrow.
	arrow _ (MorphReferenceArrowMorph new
		setVertices: (Array with: self bounds center with: evt cursorPoint);
		yourself).
	World addMorph: arrow! !


!MorphReferenceMorph methodsFor: 'initialization' stamp: 'JMV 4/23/2000 21:17'!
deleteArrow

	arrow notNil
		ifTrue: [
			arrow delete.
			arrow _ nil ]! !

!MorphReferenceMorph methodsFor: 'initialization' stamp: 'JMV 5/8/2000 19:37'!
initialize

	super initialize.
	self extent: 16@16.


! !


RectangleMorph subclass: #UpsideDownScaleMorph
	instanceVariableNames: 'caption start stop minorTick minorTickLength majorTick majorTickLength tickPrintBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-NewWidgets'!

!UpsideDownScaleMorph methodsFor: 'other' stamp: 'JMV 4/19/2000 08:59'!
buildLabels
        | scale x1 y1 y2 x captionMorph tickMorph loopStart |
        self removeAllMorphs.
        caption ifNotNil:
                [captionMorph _ StringMorph contents: caption.
                captionMorph align: captionMorph bounds bottomCenter
                                with: self bounds topCenter + (0@majorTickLength)
                                                + (0@(captionMorph height * 2 + 2)).
                self addMorph: captionMorph].
        tickPrintBlock ifNotNil:
                [scale _ (self innerBounds width-1) / (stop-start) asFloat.
                x1 _ self innerBounds left.
                y1 _ self innerBounds top + majorTickLength + 2.
                y2 _ y1 + majorTickLength.
                "Start loop on multiple of majorTick"
                loopStart _ ((start / majorTick ) ceiling) * majorTick.
                loopStart to: stop by: majorTick do:
                        [:v | x _ x1 + (scale*(v - start)).
                        tickMorph _ StringMorph contents: (tickPrintBlock value: v).
                        tickMorph align: tickMorph bounds bottomCenter
                                                with: x@y2.
                        tickMorph left < self left ifTrue:
                                [tickMorph position: self left@tickMorph top].
                        tickMorph right > self right ifTrue:
                                [tickMorph position: (self right-tickMorph width)@tickMorph top].
                        self addMorph: tickMorph]]
! !

!UpsideDownScaleMorph methodsFor: 'other' stamp: 'JMV 4/19/2000 08:55'!
extent: newExtent
	| pixPerTick newWidth |
	pixPerTick _ (newExtent x - (self borderWidth*2) - 1)
						/ ((stop-start) asFloat / minorTick).
	pixPerTick _ pixPerTick detentBy: 0.1 atMultiplesOf: 1.0 snap: false.
	newWidth _ pixPerTick * ((stop-start) asFloat / minorTick)
						+ (self borderWidth*2) + 1.
	super extent: newWidth @ newExtent y.
	self buildLabels! !

!UpsideDownScaleMorph methodsFor: 'other' stamp: 'JMV 4/19/2000 08:55'!
initialize
	super initialize.
	borderWidth _ 0.
	color _ Color lightGreen.
	start _ 0.  stop _ 100.
	minorTick _ 1.  majorTick _ 10.
	minorTickLength _ 3.  majorTickLength _ 10.
	caption _ 'sample'.  tickPrintBlock _ [:v | v printString].! !

!UpsideDownScaleMorph methodsFor: 'other' stamp: 'JMV 4/19/2000 08:55'!
start: strt stop: stp
	minorTick: mnt minorTickLength: mntLen
	majorTick: mjt majorTickLength: mjtLen
	caption: cap tickPrintBlock: blk

	start _ strt.  stop _ stp.
	minorTick _ mnt.  minorTickLength _ mntLen.
	majorTick _ mjt.  majorTickLength _ mjtLen.
	caption _ cap.  tickPrintBlock_ blk fixTemps.
	self buildLabels! !


!UpsideDownScaleMorph methodsFor: 'drawing' stamp: 'JMV 4/19/2000 08:55'!
drawOn: aCanvas
        | scale x1 y1 y2 x y3 even yy loopStart checkStart |
        super drawOn: aCanvas.
        scale _ (self innerBounds width-1) / (stop-start) asFloat.
        x1 _ self innerBounds left.
        y1 _ self innerBounds top.
        y2 _ y1 + minorTickLength.
        loopStart _ ((start / minorTick ) ceiling) * minorTick.
        loopStart to: stop by: minorTick do:
                [:v | x _ x1 + (scale*(v - start)).
                aCanvas line: x@y1 to: x@y2 width: 1 color: Color black].
        x1 _ self innerBounds left.
        y2 _ y1 + majorTickLength.
        y3 _ y1 + (minorTickLength+majorTickLength//2).
        even _ true.

        "Make sure mjor ticks start drawing on a multiple of majorTick"
        loopStart _ ((start / majorTick ) ceiling) * majorTick.
        checkStart _ ((start / (majorTick/2.0) ) ceiling) * majorTick.
        "Check to see if semimajor tick should be drawn before majorTick"
        ( checkStart = (loopStart * 2) ) ifFalse:
                        [ loopStart _ checkStart/2.0.
                                even _ false. ].
        loopStart to: stop by: majorTick/2.0 do:
                [:v | x _ x1 + (scale*(v - start)).
                yy _ even ifTrue: [y2] ifFalse: [y3].
                aCanvas line: x@y1 to: x@yy width: 1 color: Color black.
                even _ even not].
! !
